config/routes.rb
Rails.application.routes.draw do
  resources :categories
  devise_for :users
  resources :articles do
    resources :comments, only: [:create, :update, :destroy, :show]
  end
=begin
    get: '/articles' index
    post: '/articles' create
    delete: '/articles/:id' destroy
    get: '/articles/:id' show
    get: '/articles/new'
    get: '/articles/:id/edit' edit
    patch: '/articles/:id' update
    put: '/articles/:id' update
=end

   root 'welcome#index'

end

app/models/article.rb
class Article < ActiveRecord::Base
  belongs_to :user
  has_many :comments
  has_attached_file :cover, styles: { medium: "1280x720", thumb: "800x600"}
  validates_attachment_content_type :cover, content_type: /\Aimage\/.*\Z/  #permitir solo imagenes
  validates :title, :presence => {:message => "El titulo es obligatorio"}
  validates :body, :presence => {:message => "La descripcion es obligatoria"}
#   #Validaciones de nombre
#  validates :nombre, :presence => {:message => "Usted debe ingresar un nombre"}, length: {minimum: 2, maximum: 50, :message => "El nombre debe tener entre 2 y 50 caracteres"}
#  #Validaciones de apellido
#  validates :apellido, :presence => {:message => "Usted debe ingresar un apellido"}, length: {minimum: 2, maximum: 50, :message => "El apellido debe tener entre 2 y 50 caracteres"}
#  #Validaciones de legajo
#  validates :legajo, :presence => {:message => "Usted debe ingresar un legajo"}, :numericality => {:only_integer => true, :message => "El legajo debe ser numérica"}, :uniqueness => {:message => "Usted ha ingresado un legajo repetido"}
  before_save :set_vists_count

  def update_visits_count
    self.update(visits_count: self.visits_count + 1)
  end
  private

  def set_vists_count
    self.visits_count ||= 0
  end
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
  before_action :set_article, except: [:index,:new,:create]
  before_action :authenticate_user!, except: [:show,:index] #llama a un callback propio de devise
  # before_action :authenticate_user!, only: [:create,:new] # otra forma de hacerlo
  # before_action :validate_user, except: [:show, :index] # hacerlo manuelamente y luego crear el metodos
  def index
    @articles = Article.all  # las variables con @ son accesibles desd el controlador y la vista
  end
  #Get /article/:id
  def show
    @article.update_visits_count
    @comment = Comment.new
    # Article.where.not('id = ?',params[:id])
  end
  #GET /articles/new REDIRECCIONO A ESTA RUTA Y ASIGNO LOS CAMPOS DEL POST A LOS DE LA TABLA PARA LUEGO PROCEDER CON CREATE
  def new
    @article = Article.new
  end
# REDIRECCIONO A EDIT A TRAVES DEL ID Y ASIGNO LOS NUEVOS CAMPOS DEL POST A LOS DEL LA TABLA PARA LUEGO PROCEDER CON UPDATE
  def edit
  end
  #POST /articles
# RECIBO LOS CAMPOS ENVIADOS POR URL DEL NEW E INSERTO UNA NUEVA COLUMNA EN LA TABLA
  def create
    @article = current_user.articles.new(article_params) # se llama al metodo article_params
      if @article.save
        redirect_to @article  #redirecciona al articulo que se acaba de crear
      else                    #esto pasa el id del nuevo articulo por parametro que el metodo show capturara y mostrara
        render :new
      end
  end
# DESTRUYO LA COLUMNA DE LA BASE DE LA TABLA
  def destroy
    @article.destroy
    redirect_to articles_path
  end
# RECIVO LOS CAMPOS POR PATH MANDADOS POR EDIT Y ACTUALIZO EL CAMPO EN LA BASE DE DATOS
  def update
    if @article.update(article_params)
      redirect_to @article
    else
      render_to :edit
    end
  end

# Funcion para validar que solo se permita que se envie por parametro el titulo y el body (por seguridad)
  private
  def set_article
    @article = Article.find(params[:id])
  end
  # def validate_user
  #   redirect_to new_user_session_path, notice: 'Debes iniciar Sesion'
  # end
  def article_params
    params.require(:article).permit(:title,:body,:cover) #obtengo el hash enviado por url (:title,:body)
  end                                             #del form y se le asigno la tabla
end

# cuando se envia por el path un parametro que ya existe en el modelo
# entonces automaticamente entra en el metodo update,
# sino existe entra en el metodo create
#
# al redireccionar a @article se envia por el path los parametros nuevos creados
# al crearse automaticamente se le asigna un id
# entonces vuelve a ocurrir el mismo siclo si existe ese id entra en update
# sino en create

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/views/articles/_form.html.erb
<%= form_for(@article) do |f| %>
<% @article.errors.full_messages.each do |message| %>
<p>
  * <%= message%>
</p>
<%end%>
<div class="form-group">
  <%= f.text_field :title, placeholder:"Titulo", #directamente se le asigna el value al campo de la tabla
  class:"form-control" %>
</div>
<div class="form-group">
Potada: <%= f.file_field :cover%>
</div>
<div class="form-group">
  <%= f.text_area :body, placeholder: "Escribe aqui el articulo",
  class:"form-control" %>
</div>
<div class="form-group">
  <%= f.submit("Enviar", class: "btn btn-success")%>
</div>
<%end%>

app/views/articles/edit.html.erb
<h1 class="text-center">editando un nuevo articulo</h1>
<div class="container">
<!-- llamo a que incluya a la vista form, funciona como un include de php -->

  <%= render 'form' %>
</div>

app/views/articles/index.html.erb
<h1 class="text-center">Estoy en el Index</h1>
<% @articles.each do |article| %>
<h2>Escrito por: <%= article.user.email %></h2>
<h4><%= link_to article.title, article %></h4>
  <div>
    <%= article.body %> - <%= link_to 'Eliminar', article, method: :delete %>
    <%= link_to 'Editar', edit_article_path(article) %>
  </div>
<%end%>

app/views/articles/new.html.erb
<h1 class="text-center">Creando un nuevo articulo</h1>
<div class="container">
  <!-- llamo a que incluya a la vista form, funciona como un include de php -->
  <%= render 'form' %>
</div>

app/views/articles/show.html.erb
<h1 class="text-center">Pagina de Show</h1>
<div class="container">
  <h2>Escrito por: <%= @article.user.email %></h2>
  <h4><%= @article.title %> con <%= @article.visits_count%> visitas</h4>
    <%= image_tag @article.cover.url(:thumb) %>
    <%= @article.body %>
  <h2>Comentarios</h2>
  <%= render 'comments/form' %>
  <ul id="comments-box">
    <% @article.comments.each do |comment| %>
      <li><%= comment.body %> - <%= comment.user.email %> <%= comment.id %> </li>

      <%= link_to "Eliminar", [comment.article, comment], method: :delete, data: {confirm: 'Estas seguro?'} %>
    <%end%>
  </ul>
</div>